cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //    default: null,      // The default value will be used only when the component attaching
        //                           to a node for the first time
        //    url: cc.Texture2D,  // optional, default is typeof default
        //    serializable: true, // optional, default is true
        //    visible: true,      // optional, default is true
        //    displayName: 'Foo', // optional
        //    readonly: false,    // optional, default is false
        // },
        // ...
        _updating: false,
        _am: null,
        _storagePath:'',
        manifestUrl:cc.RawAsset,
        _childGame:'',
        _gameName:[],

        updatePanel:{
            default:null,
            type:cc.Node
        }
    },

    // use this for initialization
    onLoad: function () {
        this._gameName = ['starGame','tdk','32'];
    },

    // called every frame, uncomment this function to activate update callback
    // update: function (dt) {

    // },

    confirmBtn: function(object,value)
    {
        console.log('测试 '+value);
        // cc.director.loadScene('game');
        // 三种方式都可以
        // this.node.getChildByName('updatePanel').active = true;
        this.updatePanel.active = true;
        // cc.find("Canvas/updatePanel").active = true;
    },
    cancelBtn: function()
    {
        cc.game.end();
    },

    // 游戏按钮
    onBtnGameType: function(object,Type)
    {
        console.log('类型：' + typeof(Type));
        if(Type === String(1))
        {
            console.log('Type = ' + Type);
            this._childGame = this._gameName[Number(Type) - 1];
            this.getGameFile(this._childGame,1);
        }
        else if(Type == String(2))
        {
            console.log('Type = ' + Type);
        }
        else if(Type == String(3))
        {
            console.log('Type = ' + Type);
        }
    },

    /* 
        @dirName 存放游戏的文件夹名
        @tType 类型标记 1：检测是否需要更新 2：更新游戏
    */
    getGameFile: function(dirName,tType){
        // true：手机 false：web
        if(!cc.sys.isNative)
            return;
        //本地manifest文件地址和缓存manifest文件地址
        this._storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath():'/') + 'wlz-remote-assets/' + dirName ;
        // cc.log('Storage path for remote asset : ' + this._storagePath);
        console.log('Storage path for remote asset : ' + this._storagePath);
        // var UIRLFILE = 'http://klhd-cs-003.chinacloudapp.cn/wlz/hotupdate-remote-assets/' + dirName;//服务器(远端)文件地址
        // // 本地资源配置文件
        // var customManifest = JSON.stringify({
        //     "packageUrl": UIRLFILE,
        //     "remoteManifestUrl": UIRLFILE+"/project.manifest",
        //     "remoteVersionUrl" : UIRLFILE+"/version.manifest",
        //     "version": "1.0.0",
        //     "assets": {},
        //     "searchPaths": []
        // });
        var manifestFile = this._storagePath + '/project.manifest';
        // if (jsb.fileUtils.isFileExist(manifestFile))
        // {
        //     console.log('cunzai:++++++++++++++++');
        //     this.manifestUrl = manifestFile;
        // }


        var versionCompareHandle = function (versionA,versionB){
            cc.log("JS Custom Version Compare: version A is " + versionA + ', version B is ' + versionB);
            console.log("JS Custom Version Compare: version A is " + versionA + ', version B is ' + versionB);
            let vA = versionA.split('.');
            let vB = versionB.split('.');
            for(let i = 0; I < vA.length;++i)
            {
                let a = parseInt(vA[i]);
                let b = parseInt(vB[i] || 0);
                if(a === b)
                    continue;
                else 
                    return a-b;
            }
            if(vB.length > vA.length)
                return -1;
            else
                return 0;
        };
        // 创建资源管理器对象
        if(!this._am)
        {
            // if (jsb.fileUtils.isFileExist(manifestFile))
            // {
            //     console.log('cunzai:++++++++++++++++');
            //     this._am = new jsb.AssetsManager(manifestFile,this._storagePath ,versionCompareHandle);
            //     this.manifestUrl = manifestFile;
            // }
            // else
            {
                console.log('type = ' + tType);
                //准备实例化AssetsManager,简称am,第一个参数为manifest文件的路径,第二个参数为热更新资源的缓存路径,第三个参数是比较版本号的方法
                this._am = new jsb.AssetsManager(this.manifestUrl,this._storagePath ,versionCompareHandle);
                console.log('33##########################');
            }
            
        }    
        if(!cc.sys.ENABLE_GC_FOR_NATIVE_OBJECTS)
        {
            this._am.retain();
        }
        // var tInfo = this.updateInfo;
        this._am.setVerifyCallback(function(path,asset){
            let compressed = asset.compressed;
            let expecteMD5 = asset.md5;
            let relatevePath = asset.path;
            let size = asset.size;
            if(compressed)
            {
                return true;
            }
            else
            {
                return true;
            }
        });
        // this.updateInfo.string = 'Hot update is ready, please check or directly update.';
        if(cc.sys.os === cc.sys.OS_ANDROID)
        {
            this._am.setMaxConcurrentTask(2);
            // this.updateInfo.string = 'Max concurrent tasks count have been limited to 2';
        }
        // if(!this._am.getLocalManifest() || !this._am.getLocalManifest().isLoaded())
        // {
        //     return;
        // }
        if(tType === 1)
        {
            console.log('shezhijiancejianting111111-------------');
            this._updateListener = new jsb.EventListenerAssetsManager(this._am,this.checkCb.bind(this));
            console.log('shezhijiancejianting222222-------------');
        }
        else if(tType === 2)
        {
            console.log('shezhigengxinjinataing333333----------');
            this._updateListener = new jsb.EventListenerAssetsManager(this._am,this.updateCb.bind(this));
            console.log('shezhigengxinjinataing444444----------');
        }

        cc.eventManager.addListener(this._updateListener,1);
        console.log('$$$$$$$$$$$$$$$$$$$$$$');
        // if(jsb.fileUtils.isFileExist(manifestFile)){

        //     this.manifestUrl = manifestFile;
        //     this._am.loadLocalManifest(manifestFile);

        // }else{

        //     // var manifest = new jsb.Manifest(this.manifestUrl, this._storagePath );
        //     this._am.loadLocalManifest(this.manifestUrl, this._storagePath);
        // }

        if(tType === 1)
            this._am.checkUpdate();
        else if(tType === 2)
            this._am.update();
    },
    /**
     * Update events code
    enum class EventCode
    {
        ERROR_NO_LOCAL_MANIFEST,    //0 本地没有配置文件
        ERROR_DOWNLOAD_MANIFEST,    //1 下载配置文件错误
        ERROR_PARSE_MANIFEST,       //2 解析文件错误
        NEW_VERSION_FOUND,          //3 发现新的更新
        ALREADY_UP_TO_DATE,         //4 已经是最新的
        UPDATE_PROGRESSION,         //5 最新进展  做 进度的
        ASSET_UPDATED,              //6 需要更新
        ERROR_UPDATING,             //7 更新错误
        UPDATE_FINISHED,            //8 更新完成
        UPDATE_FAILED,              //9 更新失败
        ERROR_DECOMPRESS            //10 解压失败
    };
     */
    //检测
    checkCb: function(event){
        switch(event.getEventCode()){
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
                console.log('检测:本地没有配置文件');
                break;
            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
                console.log('检测:下载配置文件错误');
                break;
            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
                console.log('检测:解析文件错误');
                break;
            case jsb.EventAssetsManager.NEW_VERSION_FOUND:
                this.updatePanel.active = true;
                this.percent = this.updatePanel.getChildByName('percent').getComponent(cc.Label);
                this.updateInfo = this.updatePanel.getChildByName('info').getComponent(cc.Label);
                console.log('222222222zouzhele================');
                this.getGameFile(this._childGame,2);
                break;
            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
                console.log('1111111111zouzhele================');
                this.startChildGame();
                break;
            default:
                return;
        }
    },
    // 更新
    updateCb: function(event){
        switch(event.getEventCode()){
            case jsb.EventAssetsManager.UPDATE_PROGRESSION:
                /*5 最新进展 用于显示进度的*/
                this.percent.string = parseInt(event.getPercent()) + '%';
                break;
            case jsb.EventAssetsManager.ERROR_UPDATING:
                /*7更新错误*/
                this.updateInfo.string = '更新完成';
                break;
            case jsb.EventAssetsManager.UPDATE_FINISHED:
                /*8更新完成*/
                this.updateInfo.string = '更新完成';
                console.log('333333333333zouzhele================');
                this.startChildGame();
                break;
            case jsb.EventAssetsManager.UPDATE_FAILED:
                /*9更新失败*/
                this.getGameFile(this._childGame,1);
                break;
            case jsb.EventAssetsManager.ERROR_DECOMPRESS:
                /*10解压失败*/
                break;
            default:
                break;
        }
    },
    startChildGame: function(){
        // this.destroy();
        require(this._storagePath + '/src/main.js');
    },
});
